//	VirtualDub - Video processing and capture application
//	System library component
//	Copyright (C) 1998-2004 Avery Lee, All Rights Reserved.
//
//	Beginning with 1.6.0, the VirtualDub system library is licensed
//	differently than the remainder of VirtualDub.  This particular file is
//	thus licensed as follows (the "zlib" license):
//
//	This software is provided 'as-is', without any express or implied
//	warranty.  In no event will the authors be held liable for any
//	damages arising from the use of this software.
//
//	Permission is granted to anyone to use this software for any purpose,
//	including commercial applications, and to alter it and redistribute it
//	freely, subject to the following restrictions:
//
//	1.	The origin of this software must not be misrepresented; you must
//		not claim that you wrote the original software. If you use this
//		software in a product, an acknowledgment in the product
//		documentation would be appreciated but is not required.
//	2.	Altered source versions must be plainly marked as such, and must
//		not be misrepresented as being the original software.
//	3.	This notice may not be removed or altered from any source
//		distribution.

#ifndef f_VIRTUALDUB_CPUACCEL_H
#define f_VIRTUALDUB_CPUACCEL_H

#define CPUF_SUPPORTS_CPUID			(0x00000001L)
#define CPUF_SUPPORTS_FPU			(0x00000002L)
#define CPUF_SUPPORTS_MMX			(0x00000004L)
#define CPUF_SUPPORTS_INTEGER_SSE	(0x00000008L)
#define CPUF_SUPPORTS_SSE			(0x00000010L)
#define CPUF_SUPPORTS_SSE2			(0x00000020L)
#define CPUF_SUPPORTS_3DNOW			(0x00000040L)
#define CPUF_SUPPORTS_3DNOW_EXT		(0x00000080L)
#define CPUF_SUPPORTS_SSE3			(0x00000100L)
#define CPUF_SUPPORTS_SSSE3			(0x00000200L)
#define CPUF_SUPPORTS_SSE41			(0x00000400L)
#define CPUF_SUPPORTS_AVX			(0x00000800L)
#define CPUF_SUPPORTS_AVX2			(0x00001000L)
#define CPUF_SUPPORTS_SHA			(0x00002000L)
#define CPUF_SUPPORTS_MASK			(0x00003FFFL)

long CPUCheckForExtensions();
long CPUEnableExtensions(long lEnableFlags);
long CPUGetEnabledExtensions();
void VDCPUCleanupExtensions();

extern "C" bool FPU_enabled, MMX_enabled, SSE_enabled, ISSE_enabled, SSE2_enabled;

#endif
